注册 登录  
 加关注
   显示下一条  |  关闭
温馨提示!由于新浪微博认证机制调整,您的新浪微博帐号绑定已过期,请重新绑定!立即重新绑定新浪微博》  |  关闭

有情况

学会慢生活,拥有平常心……

 
 
 

日志

 
 

javascript 的 try catch用法  

2011-06-17 13:04:59|  分类: 编程相关 |  标签: |举报 |字号 订阅

  下载LOFTER 我的照片书  |

<script language="javascript">
try
{
throw new Error(10,"asdasdasd")
}
catch (e)
{
alert(e.message);
alert(e.description)
alert(e.number)
alert(e.name)
throw new Error(10,"asdasdasd")
}

</script>  

在JavaScript可以使用try...catch来进行异常处理。例如:  

try {  foo.bar(); } catch (e) {  alert(e.name + ": " + e.message); }

目前我们可能得到的系统异常主要包含以下6种:

  • EvalError: raised when an error occurs executing code in eval()  
  • RangeError: raised when a numeric variable or parameter is outside of its valid range  
  • ReferenceError: raised when de-referencing an invalid reference  
  • SyntaxError: raised when a syntax error occurs while parsing code in eval()  
  • TypeError: raised when a variable or parameter is not a valid type  
  • URIError: raised when encodeURI() or decodeURI() are passed invalid parameters  

上面的六种异常对象都继承自Error对象。他们都支持以下两种构造方法:

new Error(); new Error("异常信息");

手工抛出异常的方法如下:

try {  throw new Error("Whoops!"); } catch (e) {  alert(e.name + ": " + e.message); }

如要判断异常信息的类型,可在catch中进行判断:

try {  foo.bar(); } catch (e) {  if (e instanceof EvalError) {      alert(e.name + ":" + e.message);  }   else if (e instanceof RangeError) {      alert(e.name + ": " + e.message);  }   // etc  }

Error具有下面一些主要属性:

  • description: 错误描述 (仅IE可用).  
  • fileName: 出错的文件名 (仅Mozilla可用).  
  • lineNumber: 出错的行数 (仅Mozilla可用).  
  • message: 错误信息 (在IE下同description)  
  • name: 错误类型.  
  • number: 错误代码 (仅IE可用).  
  • stack: 像Java中的Stack Trace一样的错误堆栈信息 (仅Mozilla可用).  

因此为了更好的了解错误信息我们可以将catch部分改为如下形式:  

try {  foo.bar(); } catch (e) {  if (browserType != BROWSER_IE) {                                     alert("name: " + e.name +        "message: " + e.message +        "lineNumber: " + e.lineNumber +        "fileName: " + e.fileName +        "stack: " + e.stack);             }   else {                             alert("name: " + e.name +               "errorNumber: " + (e.number & 0xFFFF ) +        "message: " + e.message");             }  }

JavaScript中的throw命令事实上可以抛出任何对象,并且我们可以在catch接受到此对象。例如:

try {  throw new Date(); // 抛出当前时间对象  } catch (e) {  alert(e.toLocaleString()); // 使用本地格式显示当前时间  }
  评论这张
 
阅读(100)| 评论(0)
推荐 转载

历史上的今天

评论

<#--最新日志,群博日志--> <#--推荐日志--> <#--引用记录--> <#--博主推荐--> <#--随机阅读--> <#--首页推荐--> <#--历史上的今天--> <#--被推荐日志--> <#--上一篇,下一篇--> <#-- 热度 --> <#-- 网易新闻广告 --> <#--右边模块结构--> <#--评论模块结构--> <#--引用模块结构--> <#--博主发起的投票-->
 
 
 
 
 
 
 
 
 
 
 
 
 
 

页脚

网易公司版权所有 ©1997-2016